package com.example.garrettmoody.facerecognitionapp;

/**
 * Created by GarrettMoody on 4/14/15.
 */

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.media.FaceDetector;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.ImageView;
import android.widget.TextView;

import java.util.List;

public class MySimpleArrayAdapter extends ArrayAdapter<FaceNamePair> {
    private final List<FaceNamePair> list;
    private final Bitmap[] bitmaps;
    private final Activity context;

    public MySimpleArrayAdapter(Activity context, List<FaceNamePair> list, Bitmap[] bitmaps) {
        super(context, R.layout.row_layout, list);
        this.context = context;
        this.list = list;
        this.bitmaps = bitmaps;
    }

    static class ViewHolder {
        protected TextView text;
        protected CheckBox checkbox;
        protected ImageView image;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {
        View view = null;
        if (convertView == null) {
            LayoutInflater inflator = context.getLayoutInflater();
            view = inflator.inflate(R.layout.row_layout, null);
            final ViewHolder viewHolder = new ViewHolder();
            viewHolder.text = (TextView) view.findViewById(R.id.name);
            viewHolder.image = (ImageView) view.findViewById(R.id.icon);
            viewHolder.checkbox = (CheckBox) view.findViewById(R.id.check);
            viewHolder.checkbox
                    .setOnCheckedChangeListener(new CompoundButton.OnCheckedChangeListener() {

                        @Override
                        public void onCheckedChanged(CompoundButton buttonView,
                                                     boolean isChecked) {
                            FaceNamePair element = (FaceNamePair) viewHolder.checkbox
                                    .getTag();
                            element.setSelected(buttonView.isChecked());

                        }
                    });
            view.setTag(viewHolder);
            viewHolder.checkbox.setTag(list.get(position));
        } else {
            view = convertView;
            ((ViewHolder) view.getTag()).checkbox.setTag(list.get(position));
        }
        ViewHolder holder = (ViewHolder) view.getTag();
        holder.text.setText("Name: " + list.get(position).getName() + "\nEye Distance: " + list.get(position).getEyeDistance());
        holder.checkbox.setChecked(list.get(position).isSelected());
        holder.image.setImageBitmap(bitmaps[position]);
        return view;
    }
}
