package com.example.garrettmoody.facerecognitionapp;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.Matrix;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.media.ExifInterface;
import android.media.FaceDetector;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Message;
import android.provider.MediaStore;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.Toast;

import java.io.ByteArrayOutputStream;
import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.List;


public class matchNameWithFace extends Activity {
    public Bitmap photo;
    public ArrayList<FaceNamePair> faceNamePairArrayList;

    final Handler handler = new Handler() {
        @Override
        public void handleMessage(Message mesg) {
            throw new RuntimeException();
        }
    };


    Button.OnClickListener enterButtonClickListener = new Button.OnClickListener() {
        @Override
        public void onClick(View v) {
            EditText editText = (EditText) findViewById(R.id.enterNameText);
            final String name = editText.getText().toString();
            FaceDetector.Face newFace = findFaceInPhoto();
            final float newEyeDistance = newFace.eyesDistance();
            Uri uri = getImageUri(getApplicationContext(), photo);

            boolean nameExists = false;
            Uri existingUri = null;
            int existingID = 0;
            for (int i = 0; i < faceNamePairArrayList.size(); i++) {
                if (name.equals(faceNamePairArrayList.get(i).getName())) {
                    nameExists = true;
                    String existingUriString = faceNamePairArrayList.get(i).getUriString();
                    existingUri = Uri.parse(existingUriString);
                    existingID = faceNamePairArrayList.get(i).getID();
                    break;
                }
            }

            if (nameExists) {
                AlertDialog.Builder alertDialogBuilder = new AlertDialog.Builder(matchNameWithFace.this);
                alertDialogBuilder.setTitle("Name Exists");
                final int finalExistingID = existingID;
                Drawable d = new BitmapDrawable(getResources(), photo);
                alertDialogBuilder
                        .setMessage("The name " + name + " already exists. Create new " + name + "?")
                                //.setIcon(d)
                        .setCancelable(false)
                        .setPositiveButton("Yes", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                String uriString = getIntent().getExtras().getParcelable("imageUri").toString();
                                FaceNamePair newFaceNamePair = new FaceNamePair(name, newEyeDistance, uriString, newFaceNamePairID());
                                faceNamePairArrayList.add(newFaceNamePair);
                                handler.sendMessage(handler.obtainMessage());
                            }
                        })
                        .setNegativeButton("No, override existing", new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                String uriString = getIntent().getExtras().getParcelable("imageUri").toString();
                                FaceNamePair newFaceNamePair = new FaceNamePair(name, newEyeDistance, uriString, finalExistingID);
                                faceNamePairArrayList.add(newFaceNamePair);
                                handler.sendMessage(handler.obtainMessage());
                            }
                        });

                AlertDialog alertDialog = alertDialogBuilder.create();
                alertDialog.show();

                try {
                    Looper.loop();
                } catch (RuntimeException e2) {
                }

            } else {
                String uriString = getIntent().getExtras().getParcelable("imageUri").toString();
                FaceNamePair newFaceNamePair = new FaceNamePair(name, newEyeDistance, uriString, newFaceNamePairID());
                faceNamePairArrayList.add(newFaceNamePair);
            }

            saveFaceNamePairsToFile();
            Context context = getApplicationContext();
            Intent intent = new Intent(context, MainActivity.class);
            startActivity(intent);
        }
    };

    EditText.OnClickListener editTextClickListener = new EditText.OnClickListener() {
        @Override
        public void onClick(View v) {
            EditText editText = (EditText) findViewById(R.id.enterNameText);
            editText.setText("");
        }
    };

    public int newFaceNamePairID() {
        int ID = 1;
        for (int i = 0; i < faceNamePairArrayList.size(); i++) {
            if (ID == faceNamePairArrayList.get(i).getID()) {
                ID++;
            }
        }
        return ID;
    }

    //Getting orientation from ExifInterface
    private static int getOrientationFromExif(String imagePath) {
        int orientation = -1;
        try {
            ExifInterface exif = new ExifInterface(imagePath);
            int exifOrientation = exif.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);
            Log.i("Orientation from Exif: ", exifOrientation + "");
            switch (exifOrientation) {
                case ExifInterface.ORIENTATION_ROTATE_270:
                    orientation = 270;
                    Log.i("Orientation from Exif", "270");
                    break;
                case ExifInterface.ORIENTATION_ROTATE_180:
                    orientation = 180;
                    Log.i("Orientation from Exif", "180");
                    break;
                case ExifInterface.ORIENTATION_ROTATE_90:
                    Log.i("Orientation from Exif", "90");
                    orientation = 90;
                    break;
                case ExifInterface.ORIENTATION_NORMAL:
                    orientation = 0;
                    Log.i("Orientation from Exif", "0 - Normal");
                    break;
                case ExifInterface.ORIENTATION_UNDEFINED:
                    orientation = -1;
                    Log.e("Orientation from Exif", "UNDEFINED");
            }
        } catch (IOException e) {
        }
        return orientation;
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_match_name_with_face);

        Uri imageUri = getIntent().getExtras().getParcelable("imageUri");
        photo = grabImage(imageUri);

        int orientation = getOrientationFromExif(imageUri.getPath());
        Matrix matrix = new Matrix();
        matrix.postRotate(orientation);
        Bitmap rotatedBitmap = Bitmap.createBitmap(photo, 0, 0, photo.getWidth(), photo.getHeight(), matrix, true);

        photo = rotatedBitmap;
        ImageView imageView = (ImageView) findViewById(R.id.matchImageView);
        imageView.setImageBitmap(rotatedBitmap);

        Button enterButton = (Button) findViewById(R.id.enterButton);
        enterButton.setOnClickListener(enterButtonClickListener);

        EditText editText = (EditText) findViewById(R.id.enterNameText);
        editText.setOnClickListener(editTextClickListener);

        List<FaceNamePair> faceNamePairList = loadFaceNamePairsFromFile();
        if (faceNamePairList != null) {
            faceNamePairArrayList = new ArrayList<>(faceNamePairList.size());
            faceNamePairArrayList.addAll(faceNamePairList);
        } else {
            faceNamePairArrayList = new ArrayList<>(0);
        }
    }

    public Bitmap grabImage(Uri uriSavedImage) {
        Bitmap bitmap = null;
        try {
            bitmap = MediaStore.Images.Media.getBitmap(this.getContentResolver(), uriSavedImage);
        } catch (Exception e) {
            Toast.makeText(this, "Failed to load", Toast.LENGTH_SHORT).show();
        }

        return bitmap;
    }

    public FaceDetector.Face findFaceInPhoto() {
        FaceDetector.Face face[] = new FaceDetector.Face[1];

        //photo.reconfigure(photo.getWidth(), photo.getHeight(), Bitmap.Config.RGB_565);
        Bitmap newPhoto = photo.copy(Bitmap.Config.RGB_565, true);

        FaceDetector faceDetector;
        faceDetector = new FaceDetector(newPhoto.getWidth(), newPhoto.getHeight(), 1);
        int facesFound = faceDetector.findFaces(newPhoto, face);

        if (facesFound < 1) {
            Toast.makeText(getApplicationContext(), "No faces found.", Toast.LENGTH_LONG);
        } else if (facesFound > 1) {
            Toast.makeText(getApplicationContext(), "Too many faces found.", Toast.LENGTH_LONG);
        }
        return face[0];
    }

    public Uri getImageUri(Context inContext, Bitmap inImage) {
        ByteArrayOutputStream bytes = new ByteArrayOutputStream();
        inImage.compress(Bitmap.CompressFormat.JPEG, 100, bytes);
        String path = MediaStore.Images.Media.insertImage(inContext.getContentResolver(), inImage, "Title", null);
        return Uri.parse(path);
    }

    public void saveFaceNamePairsToFile() {
        Context context = getApplicationContext();
        File faceNamePairsFile = new File(context.getFilesDir(), "FaceNamePairs.ser");

        String filename = faceNamePairsFile.getPath();
        FileOutputStream fos = null;
        ObjectOutputStream out = null;
        try {
            fos = new FileOutputStream(filename);
            out = new ObjectOutputStream(fos);
            for (int i = 0; i < faceNamePairArrayList.size(); i++) {
                out.writeFloat(faceNamePairArrayList.get(i).getEyeDistance());
                out.writeInt(faceNamePairArrayList.get(i).getID());
                out.writeObject(faceNamePairArrayList.get(i).getName());
                out.writeObject(faceNamePairArrayList.get(i).getUriString());
            }

            out.close();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public List<FaceNamePair> loadFaceNamePairsFromFile() {
        Context context = getApplicationContext();
        File contactsFile = new File(context.getFilesDir(), "FaceNamePairs.ser");
        if (!contactsFile.exists() || contactsFile.length() == 0) {
            List<FaceNamePair> emptyList = null;
            return emptyList;
        }

        List<FaceNamePair> loadedFaceNamePairs = new ArrayList<>();

        FileInputStream fileInputStream;
        try {
            fileInputStream = new FileInputStream(contactsFile);
        } catch (FileNotFoundException e) {
            Toast.makeText(getApplicationContext(), "Nothing to load.", Toast.LENGTH_LONG);
            return new ArrayList<>();
        }

        try {
            ObjectInputStream ois = new ObjectInputStream(fileInputStream);
            boolean again = true;
            while (again) {
                float eyeDistance = ois.readFloat();
                int ID = ois.readInt();
                String name = (String) ois.readObject();
                String Uri = (String) ois.readObject();
                FaceNamePair newFace = new FaceNamePair(name, eyeDistance, Uri, ID);
                loadedFaceNamePairs.add(newFace);
                if (newFace == null)
                    again = false;
            }

            ois.close();
            fileInputStream.close();
        } catch (EOFException e)
        //ignore
        {
        } catch (IOException | ClassNotFoundException e) {
            e.printStackTrace();
        }

        return loadedFaceNamePairs;
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_match_name_with_face, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
